<?php
declare(strict_types=1);

namespace Ep\Gath;

use Ep\Gath\Plugin\Products;

/**
 * Class ImageManager
 *
 * @package Ep\Gath
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/ep-gath
 */
class ImageManager
{
    /** @var array */
    private static $images = [];

    /**
     * @param string $path
     * @return int
     */
    public function getImageId(string $path)
    {
        global $wp_version;

        if (version_compare( $wp_version, '5.0', '<' ) ) {
            return 'gath-' . $path;
        }

        $id = array_search($path, self::$images, true);

        if ($id === false) {
            $id = intval(count(self::$images) + 1 + Products::ID_OFFSET_ATTACHMENT);
            self::$images[$id] = $path;
        }

        return $id;
    }

    /**
     * @param int $id
     * @return string
     */
    public function getImage(int $id): ?string
    {
        return self::$images[$id] ?? null;
    }
}
