<?php
namespace Ep\Gath\Widget;

use Ep\Gath\Moto\SelectMotorcycleView;
use Ep\Wp\Widget\AbstractWidget;
use Laminas\View\Renderer\RendererInterface;

/**
 * Class SelectMotorcycle
 *
 * @package Gath\Moto\Widget
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/gath-moto
 *///        if (!defined('WP_ADMIN'))
class SelectMotorcycleWidget extends AbstractWidget
{
    /** @var RendererInterface */
    private $renderer;
    /** @var SelectMotorcycleView */
    private $view;

    /**
     * SelectMotorcycle constructor.
     *
     * @param RendererInterface $renderer
     * @param SelectMotorcycleView $view
     */
    public function __construct(
        RendererInterface $renderer,
        SelectMotorcycleView $view
    ) {
        parent::__construct('gath_moto_selectmotorcycle', 'Odabir motocikla', [
            'classname' => 'gath-moto-selectmotorcycle',
            'description' => 'Omogućuje odabir motocikla za povezivanje s proizvodima.',
        ]);

        $this->renderer = $renderer;
        $this->view = $view;

        add_action('admin_enqueue_scripts', [$this, 'admin_enqueue_scripts']);
    }

    public function admin_enqueue_scripts()
    {
        wp_enqueue_script('media-upload');
        wp_enqueue_media();
    }

    /**
     * @param array $instance
     */
    public function form($instance)
    {
        echo $this->renderer->render('@gath/moto/widget/select-motorcycle-settings.html.twig', [
            'title' => $instance['title'] ?? '',
            'title_id' => $this->get_field_id('title'),
            'title_label' => __('Title:'),
            'title_name' => $this->get_field_name('title'),

            'image' => $instance['image'] ?? '',
            'image_button_label' => __('Choose Image'),
            'image_id' => $this->get_field_id('image'),
            'image_label' => __('Image:'),
            'image_name' => $this->get_field_name('image'),
        ]);
    }

    /**
     * @param array $args
     * @param array $instance
     */
    public function widget($args, $instance)
    {
        echo $this->view->render([
            'image_id' => $instance['image'] ?? false,
            'title' => $instance['title'] ?? false,
        ]);
    }
}
