<?php
namespace EpTest\Gath;

use Ep\Gath\ConfigProvider;
use Laminas\ConfigAggregator\ArrayProvider;
use Laminas\ConfigAggregator\ConfigAggregator;
use Laminas\ServiceManager\ServiceManager;
use Laminas\Stdlib\ArrayUtils;

/**
 * Koristi se za testove integracije.
 *
 * @package EpTest\Gath
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/gath
 */
trait IntegrationTestTrait
{
    /**
     * Vraća friški iskonfigurirani container.
     *
     * @param array $config Dodatna konfiguracija.
     *
     * @return ServiceManager
     */
    protected function createContainer(array $config = [])
    {
        if (!defined('ABSPATH')) {
            define('ABSPATH', dirname(__DIR__) . '/wordpress/');
        }

        if (!defined('WPINC')) {
            define('WPINC', 'wp-includes');
        }

        $config = (new ConfigAggregator([
            ConfigProvider::class,
            new ArrayProvider(ArrayUtils::merge([
                'gath' => [
                    'base_uri' => 'http://192.168.56.20:57032/'
                ],
            ], $config)),
        ]))->getMergedConfig();

        $container = new ServiceManager($config['dependencies'] ?? []);
        $container->setService('config', $config);

        return $container;
    }
}